#include <sdsl/suffix_arrays.hpp>
#include <fstream>
#include <string>
#include "mycsa.hpp"  // definition of my_csa type

using namespace std;

int main(int argc, char** argv) {
  if(argc!=2) {
    cout << "Usage " << argv[0] << " input_file" << endl;
    cout << "    Create a csa (fm_index+wt) for the input file and save it with extension csa" << endl;
    return 1;
  }
  // define type of CSA and construct
  my_csa fm_index;
  construct(fm_index, argv[1], 1);
  
  cout << "Index construction complete, index uses " << size_in_mega_bytes(fm_index) << " MiB." << endl;
  size_t n = fm_index.size();
  cout << "BWT has size " << n << endl;
  // store index to file
  store_to_file(fm_index, string(argv[1])+"."+to_string(TEXT_DENS)+".csa");
  // uncomment the next 2 lines to output the graphic representation of used space
  //  ofstream out(string(argv[1])+"."+to_string(TEXT_DENS)+".csa.html");
  //  write_structure<HTML_FORMAT>(fm_index,out);
  return 0;
}
